@0xd4d97e2cea03a846;  # unique file ID, generated by `capnp id`

struct SetupArgs {
  version @0 :Text;
  activePins @1 :List(Int32);
}

enum HardwareType {
  v1 @0;
  v2 @1;
}

struct SetupResponse {
  versionOk @0 :Bool;
  hardwareType @1 :HardwareType;
}

struct PinControl {
  pin @0 :UInt8;
  target @1 :Float32;
}

struct ControlArgs {
  setPins @0 :List(PinControl);
}

struct ReadSensorsArgs {
  readPins @0 :List(Int32);
}

struct ControlAndReadSensorsArgs {
  setPins @0 :List(PinControl);
  readPins @1 :List(Int32);
}

struct Vector3 {
  x @0 :Float32;
  y @1 :Float32;
  z @2 :Float32;
}

struct Image {
  r @0 :List(Int32);
  g @1 :List(Int32);
  b @2 :List(Int32);
}

struct SensorReadings {
  pins @0 :List(Float32);
  battery @1 :Float32;
  imuOrientation @2 :Vector3;
  imuSpecificForce @3 :Vector3;
  imuAngularRate @4 :Vector3;
  cameraView @5 :Image;
}

interface RoboServer {
  setup @0 (args :SetupArgs) -> (response :SetupResponse);
  control @1 (args :ControlArgs);
  readSensors @2 (args :ReadSensorsArgs) -> (response :SensorReadings);
  controlAndReadSensors @3 (args :ControlAndReadSensorsArgs) -> (response :SensorReadings);
}
